puts "##################################################"
puts "#"
puts "# This is output of trapd.conf convert tool."
puts "# This tool does not present the complete"
puts "# conversion."
puts "# You should check the output according to the"
puts "# messages in the output."
puts "#"

# process to read line of file
proc getline { _fid _line _number } {
	upvar $_line _LINE
	upvar $_number _NUMBER
	if { [eof $_fid] != 0 } {
		return -1
	}
	incr _NUMBER
	return [gets $_fid _LINE]
}

# initialize value
set _number 0
set _SNMPTRAP ".1.3.6.1.6.3.1.1.5"

# check argument
if { $argc < 1 } {
	puts "$argv0 HP_config_file_name"
	exit
}

# open HP config file
set _hpfile [lindex $argv 0]
set _hpfid [open "$_hpfile" ]

# set output file id
set _fid stdout
if { $argc > 1 } {
	set _output_file [lindex $argv 1]
	set _fid [open "$_output_file" w ]
}

# -------------------------------
while { [getline $_hpfid _line _number ] != -1 } {
	# get EVENT record
	if { [regexp {^EVENT } $_line] < 1 } {
		continue
	}
	if { [llength $_line] < 5 } {
		continue
	}

	set _event_name     [lindex $_line 1]
	set _event_oid      [lindex $_line 2]
	set _event_category [lindex $_line 3]
	set _event_severity [lindex $_line 4]

	# search wild-card-charactor in EOID
	if { [regexp {\*$} $_event_oid] > 0 } {
		puts "## $_event_name (EOID=$_oid) definition begin (source: $_number)"
		puts "# $_line"
		puts "##!! Error !! Wild-card-charactor. Not support."
		puts "#"
		puts "#"
		continue;
	}

	# convert OID from dot to mib
	regsub -- {^\.1\.3\.6\.1\.4\.1} $_event_oid "enterprises" _oid
	regsub -- {^\.1\.3\.6\.1\.6\.3\.1\.1\.5} $_oid "snmpTraps" _oid
	regsub -- {^\.1\.3\.6\.1\.2} $_oid "mgmt" _oid

	# EID
	switch -regexp -- $_event_oid {
		# EID=.1.3.6.1.6.3.1.1.5.[1-6]
		{^\.1\.3\.6\.1\.6\.3\.1\.1\.5\.[1-6]$} {
			set _enterprise $_SNMPTRAP
			set _idlist [split $_event_oid "\."]
			set _i [llength $_idlist]
			incr _i -1
			set _generic [lindex $_idlist $_i]
			incr _generic -1
			set _specific "-"
			set _trap_type "GENERIC"
		}
		# EID=.1.3.6.1.6.3.1.1.5.[1-6],,,
		{\.1\.3\.6\.1\.6\.3\.1\.1\.5\.[1-6].+} {
			set _enterprise $_event_oid
			regsub -- "$_SNMPTRAP\." $_enterprise "" _enterprise

			set _idlist [split $_enterprise "\."]
			set _generic [lindex $_idlist 0]
			incr _generic -1
			regsub -- {[1-6]} $_enterprise "" _enterprise
			set _specific "-"
			set _trap_type "GENERIC"
		}
		# EID=.A.B.,,,.0.X,,,
		{\.([0-9]+\.)+0\.+} {
			regsub -- {\.0(\..*$|$)} $_event_oid "" _enterprise
			set _generic 6
			set _idlist [split $_event_oid "\."]
			set _specific [lindex $_idlist [expr [llength $_idlist] - 1]]
			set _trap_type "SNMPv1"
		}
		# other
		default {
			puts "## $_event_name (EOID=$_oid) definition begin (source: $_number)"
			puts "# $_line"
			puts "##!! Error !! SNMP-V2 Trap definition. Not support."
			puts "#"
			puts "#"
			continue;
		}
	}

	# convert Enterprise OID from dot to mib
	regsub -- {^\.1\.3\.6\.1\.4\.1} $_enterprise "enterprises" _oid
	regsub -- {^\.1\.3\.6\.1\.6\.3\.1\.1\.5} $_oid "snmpTraps" _oid
	regsub -- {^\.1\.3\.6\.1\.2} $_oid "mgmt" _oid
	regsub -- {^\.} $_enterprise "" _enterprise

	# output comment
	puts $_fid "## $_event_name ( Enterprise=$_oid $_enterprise ) definition begin (source: $_number)"
	puts $_fid "# $_line"

	# get new line and output comment
	while { [getline $_hpfid _line _number ] != -1 } {
		puts $_fid "# $_line"
		if { [regexp {^EDESC *} $_line] > 0 } {
			break
		}
		if { [regexp {^FORMAT *} $_line] > 0 } {
			set _format_string $_line
			regsub -- {^FORMAT *} $_format_string "" _format_string
		}
	}
	# last _line is EDESC ?
	if { [regexp {^EDESC *} $_line] == 0 } {
		puts "##!! Error !! $_hpfile has no last 'EDESC'"
		puts "#"
		puts "#"
		break
	}

	# print Warning string to converted
	set _FORMAT "##!! Warning !! Systemwalker will add all of varbind parameter. Variable %s not converted. You should check the message text."
	if { [regexp {\$#} $_format_string] > 0 } {
		puts $_fid [format $_FORMAT "\$#"]
	}
	if { [regexp {\$\*} $_format_string] > 0 } {
		puts $_fid [format $_FORMAT "\$\*"]
	}
	if { [regexp {\$>[+-]?[0-9]+} $_format_string] > 0 } {
		set _value [regexp -all -inline -- {\$>[+-]?[0-9]+} $_format_string]
		regsub -all -- {\{|\}} $_value {} _value
		regsub -all -- { } $_value {, } _value
		puts $_fid [format $_FORMAT "$_value (regular expression pattern is \$>\[+-\]?\[0-9\]+)"]
	}
	set _FORMAT "##!! Warning !! Systemwalker will add trap recipt time and date. Variable %s not converted. You should check the message text."
	if { [regexp {\$x} $_format_string] > 0 } {
		puts $_fid [format $_FORMAT "\$x"]
	}
	if { [regexp {\$X} $_format_string] > 0 } {
		puts $_fid [format $_FORMAT "\$X"]
	}
	if { [regexp {\$@} $_format_string] > 0 } {
		puts $_fid [format $_FORMAT "\$@"]
	}

	# convert keywords on format_string
	regsub -all -- {\$O} $_format_string $_event_oid  _format_string
	regsub -all -- {\$o} $_format_string $_event_name _format_string
	regsub -all -- {\$V} $_format_string $_trap_type  _format_string

	# print Warning string to converted, again
	set _FORMAT "##!! Warning !! Systemwalker will add trap source name. Variable %s not converted. You should check the message text."
	if { [regexp {\$r} $_format_string] > 0 } {
		puts $_fid [format $_FORMAT "\$r"]
	}
	if { [regexp {\$R} $_format_string] > 0 } {
		puts $_fid [format $_FORMAT "\$R"]
	}
	if { [regexp {\$c} $_format_string] > 0 } {
		puts $_fid "##!! Warning !! Systemwalker not support CATEGORY. Variable \$c not converted. You should check the message text."
	}
	if { [regexp {\$s} $_format_string] > 0 } {
		puts $_fid "##!! Warning !! Systemwalker will add Severity information. Variable \$s not converted. You should check the message text."
	}
	set _FORMAT "##!! Warning !! Variable %s not converted. You should check the message text."
	if { [regexp {\$N} $_format_string] > 0 } {
		puts $_fid [format $_FORMAT "\$N"]
	}
	if { [regexp {\$F} $_format_string] > 0 } {
		puts $_fid [format $_FORMAT "\$F"]
	}

	# copy string value from format_string to control_string
	set _control_string $_format_string

	# convert variable string
	regsub -all -- {\$C} $_format_string "%COMMUNITY%"  _format_string
	regsub -all -- {\$E} $_format_string "%ENTERPRISE%" _format_string
	regsub -all -- {\$e} $_format_string $_enterprise   _format_string
	regsub -all -- {\$A} $_format_string "%AGENT_ADDR%" _format_string
	regsub -all -- {\$G} $_format_string $_generic      _format_string
	regsub -all -- {\$S} $_format_string $_specific     _format_string
	regsub -all -- {\$T} $_format_string "%TIME_STAMP%" _format_string

	regsub -all -- {\$C} $_control_string "%%community%%"  _control_string
	regsub -all -- {\$E} $_control_string "%%enterprise%%" _control_string
	regsub -all -- {\$e} $_control_string $_enterprise   _control_string
	regsub -all -- {\$A} $_control_string "%AGENT_ADDR%" _control_string
	regsub -all -- {\$G} $_control_string $_generic      _control_string
	regsub -all -- {\$S} $_control_string $_specific     _control_string
	regsub -all -- {\$T} $_control_string "%TIME_STAMP%" _control_string

	set _prev_varbind 1
	set _currnet_varbind ""
	set _rstart 0
	# convert \$[+-]?[0-9][0-9]? ... ($1 $+2 $-13)
	while { [regexp {\$[+-]?[0-9][0-9]?} $_format_string] > 0 } {
		# get matching string
		regexp {\$[+-]?[0-9][0-9]?} $_format_string _match
		# string has '+' or '-'?
		if { [regexp {[+-]} $_match] > 0 } {
			# sign on
			regexp {[+-]} $_match _sign
		} else {
			# sign off
			set _sign ""
		}
		# get varbind number
		regexp {[0-9][0-9]?} $_match _current_varbind

		set _convert_data ""
		# set locater
		set _locater [expr $_current_varbind - $_prev_varbind]
		# set varbind position
		if { $_locater > 0 } {
			for { set _i 0 } { $_i < $_locater } { incr _i } {
				set _convert_data "$_convert_data %NEXT_V%"
			}
		} elseif { $_locater < 0 } {
			for { set _i 0 } { $_i > $_locater } { incr _i -1 } {
				set _convert_data "$_convert_data %BACK_V%"
			}
		}
		# set previous varbind
		set _prev_varbind $_current_varbind
		if { [string equal $_sign ""] > 0 } {
			# string has no sign
			set _convert_data "$_convert_data %VARBIND_VALUE%"
			set _control_data "%%$_current_varbind-varbindvalue%%"
		} elseif { [string equal $_sign "-"] > 0 } {
			# string has '-' sign
			set _FORMAT "%s \[%s\] %%VARBIND_NAME%%(%%VARBIND_TYPE%%)F%%VARBIND_VALUE%%"
			set _convert_data [ format $_FORMAT $_convert_data $_current_varbind ]
			set _FORMAT "\[%s\] %%%%%s-varbindname%%%%(%%VARBIND_TYPE%%)F%%%%%s-varbindvalue%%%%"
			set _control_data [format $_FORMAT $_current_varbind $_current_varbind $_current_varbind]
		} else {
			# string has '+' sign
			set _FORMAT "%s %%VARBIND_NAME%%F%%VARBIND_VALUE%%"
			set _convert_data [format $_FORMAT $_convert_data]

			set _FORMAT "%%%%%s-varbindname%%%%F%%%%%s-varbindvalue%%%%"
			set _control_data  [format $_FORMAT $_current_varbind $_current_varbind]
		}
		# convert varbind string
		regsub -- {\$[+-]?[0-9][0-9]?} $_format_string $_convert_data _format_string
		regsub -- {\$[+-]?[0-9][0-9]?} $_control_string $_control_data _control_string
	}
	# convert \" -> \\"
	regsub -all -- {\"} $_format_string "\\\"" _format_string
	regsub -all -- {\"} $_control_string "\\\"" _control_string

	# all charactors of format string is ASCII ?
	if { [string is ascii $_format_string] != 1 } {
		# Japanese
		set _JMSG $_format_string
		set _EMSG $_event_name
		set _LANG "JP"
		puts $_fid "##!! Warning !! There is no English message text specified. Trap-name will be used as English message text."
	} else {
		# all ASCII
		set _JMSG $_format_string
		set _EMSG $_format_string
		set _LANG "C"
		puts $_fid "##!! Warning !! There is no Japanese message text specified. English message text will be used as Japanese one."
	}

	# set event type
	switch -- $_event_severity {
		# Normal
		"Normal" {
			set _EVENTTYPE "INFORMATION"
			puts $_fid "##!! Warning !! This trap will noto appear alerm monitoring windows. If you want to monitor this trap, you should change EVENTTYPE parameter."
		}
		# Warning
		"Warning" {
			set _EVENTTYPE "WARNING"
		}
		# other
		default {
			set _EVENTTYPE "ERROR"
		}
	}

	set _value_count 0
	set _value_list ""
	# control string has keyword ?
	while { [regexp {%%(community|enterprise|[0-9][0-9]?-varbindname|[0-9][0-9]?-varbindvalue)%%} $_control_string] > 0 } {
		# get control string
		regexp {%%(community|enterprise|[0-9][0-9]?-varbindname|[0-9][0-9]?-varbindvalue)%%} $_control_string _string
		set _column 0
		# get index of control string
		set _index [string first $_string $_control_string]
		# count column number
		for { set _i 0 } { $_i < $_index } { incr _i } {
			if { [string is ascii [string index $_control_string $_i]] } {
				# ASCII
				incr _column
			} else {
				# not ASCII
				incr _column 2
			}
		}
		# delete %%
		regsub -all -- {%%} $_string "" _string
		# convert string
		switch -regexp -- $_string {
			community {
				set _FORMAT "#     variable : kind=Community,top-column=%d,length=9"
				set _value [format $_FORMAT $_column]
				lappend _value_list $_value
			}
			enterprise {
				set _FORMAT "#     variable : kind=EnterpriseOID,top-column=%d,length=10"
				set _value [format $_FORMAT $_column]
				lappend _value_list $_value
			}
			{[0-9][0-9]?-varbindname} {
				regsub -- {-varbindname} $_string "" _varbind_index
				set _length [string bytelength $_string]
				set _FORMAT "#     variable : kind=Varbind-Name,index=%d,top-column=%d,length=%d"
				set _value [format $_FORMAT $_varbind_index $_column $_length]
				lappend _value_list $_value
			}
			{[0-9][0-9]?-varbindvalue} {
				regsub -- {-varbindvalue} $_string "" _varbind_index
				set _length [string bytelength $_string]
				set _FORMAT "#     variable : kind=Varbind-Value,index=%d,top-column=%d,length=%d"
				set _value [format $_FORMAT $_varbind_index $_column $_length]
				lappend _value_list $_value
			}
			default {
				# program error
				puts "pattern match error"
				break
			}
		}
		# convert control string
		regsub -- "%%${_string}%%" $_control_string $_string _control_string
		incr _value_count
	}

	# value_list has string data ?
	if { $_value_count > 0 } {
		# output comment
		puts $_fid "# Variable information in message"
		puts $_fid [format "#   message-J  : %s" $_control_string]
		for { set _i 0 } { $_i < $_value_count } { incr _i } {
			puts $_fid [lindex $_value_list $_i]
		}
		if { [string equal $_LANG "C" ] } {
			puts $_fid [format "#   message-E  : %s" $_control_string]
			for { set _i 0 } { $_i < $_value_count } { incr _i } {
				puts $_fid [lindex $_value_list $_i]
			}
		} else {
			puts $_fid [format "#   message-E  : %s" $_EMSG]
		}
		puts $_fid "# End of Variable information in message"
	}

	# output TRAP_to_EVENT definition
	puts $_fid "TRAP:"
	puts $_fid [format " - 4 - - %s - %s %s - " $_enterprise $_generic $_specific]
	puts $_fid "VARBIND:"
	puts $_fid " - - - -"
	puts $_fid "MESSAGE:"
	puts $_fid "SmallJ:"
	puts $_fid [format " \"\[%%%%hostx:%%AGENT_ADDR%%\] %s\" " $_JMSG]
	puts $_fid "SmallE:"
	puts $_fid [format " \"\[%%%%hostx:%%AGENT_ADDR%%\] %s\" " $_EMSG]
	puts $_fid "EVENTTYPE:"
	puts $_fid [format " %s" $_EVENTTYPE]
	puts $_fid "Threshold:"
	puts $_fid " 1"
	puts $_fid [format "## %s ( Enterprise=%s ) definition end " $_event_name $_oid ]
	puts $_fid  ""
	puts $_fid  ""
	puts $_fid  ""

}

# close input file id
close $_hpfid

# output file id is stdout ?
if { [string equal $_fid stdout] != 1 } {
	# close output file id
	close $_fid
}

